#!/usr/bin/perl
#use locale;
#------------------------------------------------------------#
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) 
 {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
 }
$temp = $ENV{'QUERY_STRING'};
@pairs = split(/&/,$temp);
foreach $item(@pairs) 
 {
  ($key, $content) = split (/=/, $item, 2);
  $content =~ tr/+/ /;
  $content =~ s/%(..)/pack("c",hex($1))/ge;
  $FORM{$key} = $content;
 }
#------------------------------------------------------------#
sub get_WORD
 { return unpack "v", (substr $_[0],$_[1],4); }

sub get_DWORD
 { return unpack "V", (substr $_[0],$_[1],4); }

sub get_WORD_symbols
 { return pack "v", $_[0]; }

sub get_DWORD_symbols
 { return pack "V", $_[0]; }

sub read_block
 {
  if(!-r $_[0]){ $stat_info .= (":  ".$_[0]."<br>       !<br>"); reset_document(); };
  open FILE,$_[0];
  $stat_info .= ($_[2]."    ".$_[1]."<br>");
  binmode FILE;
  seek FILE,$_[1],0; read FILE,$_[3],$_[2];
  close FILE;
 }

sub get_date
 {
  ($day, $mn, $yr) = (localtime)[3..5];
  if($day < 10){ $day = "0$day"; };
  $mn = ($mn < 10) ? "0($mn+1)" : ($mn+1);
  if($yr < 2000){ $yr += 1900; };
  return "$day$mn$yr";
 }

sub get_time
 {
  ($sec, $min, $hour) = (localtime)[0..2];
  if($sec < 10){ $sec = "0$sec"; };
  if($min < 10){ $min = "0$min"; };
  if($hour < 10){ $hour = "0$hour"; };
  return "$hour:$min:$sec";
 }

sub reset_document
 {
  $stat_info =~ s/\x5c/\\x5c/g;
  my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";
  print <<HTML;
  <script type='text/javascript'><!--
  parent.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == 1) ? ("$full_stat_info" + parent.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
  parent.document.block_search_form.reset();
  parent.FLAG_no_action = 0;
  parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
  // --></script>
HTML

  exit;
 }
#-----------------------------------------------------------------------#
print "content-type: text/html; charset=Windows-1251\n\n";

if($FORM{'search_text'})
 {
  $search_text = $FORM{'search_text'};
  #    
  $search_text =~ s/\\/\\x5c/g;
  $search_text =~ s/\$/\\x24/g;
  $search_text =~ s/\^/\\x5e/g;
  $search_text =~ s/\*/\\x2a/g;
  $search_text =~ s/\(/\\x28/g;
  $search_text =~ s/\)/\\x29/g;
  $search_text =~ s/\+/\\x2b/g;
  $search_text =~ s/\"/\\x22/g;
  $search_text =~ s/\?/\\x3f/g;
  $search_text =~ s/\|/\\x7c/g;
  $search_text =~ s/\[/\\x5b/g;
  $search_text =~ s/\./\\x2e/g;
 };

if($FORM{'replace_text'})
 {
  $replace_text = $FORM{'replace_text'};
  #    
  $replace_text =~ s/\"/\\x22/g;
  $replace_text =~ s/\./\\x2e/g;
  $replace_text =~ s/\,/\\x2c/g;
 };

#   
@search_text_splited = split "{!AND!}",$search_text;
if($search_text_splited[0] ne ""){ $search_text_1 = $search_text_splited[0]; }else{ $search_text_1 = "{!NULL!}"; }
if($search_text_splited[1] ne ""){ $search_text_2 = $search_text_splited[1]; }else{ $search_text_2 = "{!NULL!}"; }
if($search_text_splited[2] ne ""){ $search_text_3 = $search_text_splited[2]; }else{ $search_text_3 = "{!NULL!}"; }
if($search_text_splited[3] ne ""){ $search_text_4 = $search_text_splited[3]; }else{ $search_text_4 = "{!NULL!}"; }
if($search_text_splited[4] ne ""){ $search_text_5 = $search_text_splited[4]; }else{ $search_text_5 = "{!NULL!}"; }
if($search_text_splited[5] ne ""){ $search_text_6 = $search_text_splited[5]; }else{ $search_text_6 = "{!NULL!}"; }
if($search_text_splited[6] ne ""){ $search_text_7 = $search_text_splited[6]; }else{ $search_text_7 = "{!NULL!}"; }
if($search_text_splited[7] ne ""){ $search_text_8 = $search_text_splited[7]; }else{ $search_text_8 = "{!NULL!}"; }
if($search_text_splited[8] ne ""){ $search_text_9 = $search_text_splited[8]; }else{ $search_text_9 = "{!NULL!}"; }

#  
if(!-r $FORM{'main_file'})
 {
  $stat_info .= (":  ".$FORM{'main_file'}."       !<br>");
  reset_document();
 };
open FILE,$FORM{'main_file'};
#     ( )
(undef, undef, undef, undef, undef, undef, undef, $file_size) = stat FILE;
#  
close FILE;
if($FORM{'file_size'} ne $file_size)
 {
  $stat_info .= ("  : ".$FORM{'main_file'}." ...<br>");
  $stat_info .= ("->     ... ");
  read_block($FORM{'main_file'},0,20,$header);
  #   
  $file_type = substr $header,0,4;
  if($file_type ne "TLK ")
   {
    $stat_info .= (":   ".$file_type."   !<br>");
    reset_document();
   };
  #  
  $file_version = substr $header,4,4;
  #  
  %language_list = ('0','', '1','', '2','', '3','', '4','', '5','', '128','', '129',' ', '130',' ', '131','');
  #   (    )
  $languageID = ($file_version eq "V3.0") ? get_DWORD($header,8) : get_WORD($header,8);
  $file_language = $language_list{$languageID};
  #     
  $file_strings = ($file_version eq "V3.0") ? get_DWORD($header,12) - 1 : get_DWORD($header,10) - 1;
  #        
  $strings_offset = ($file_version eq "V3.0") ? get_DWORD($header,16) : get_DWORD($header,14);
 }
else
 {
  #        
  $file_size = $FORM{'file_size'};
  $file_type = $FORM{'file_type'};
  $file_version = $FORM{'file_version'};
  $file_strings = $FORM{'file_strings'};
  $strings_offset = $FORM{'strings_offset'};
 }  
if($file_version eq "V3.0"){ $header_length = 20; $string_data_length = 40; }
else{ $header_length = 18; $string_data_length = 26; }

#   
my $match_count = 0;
#    
if($FORM{'search_in_matched'})
 { @search_in = split ",",$FORM{'matched_strings_joined'}; };
#     
if($FORM{'search_from_this'})
 { $start_search_position =  ($FORM{'search_in_matched'}) ? @search_in[0] : $FORM{'string_number'}; }
#     
else{ $start_search_position = ($FORM{'search_in_matched'}) ? @search_in[0] : 0; }

  $search_text_for_stat = "";
  for $sts(0..$#search_text_splited)
   { 
    $current_block = $search_text_splited[$sts]; $current_block =~ s/</&lt;/g;
    $search_text_for_stat .= ("<p style='border: dotted 1px grey; color: green; font: italic 9px arial; padding: 2px; margin: 2px 1px 0px 5px'>".$current_block."</p>");
   }

  $search_text_for_stat =~ s/\\x2e/\./g;
  $search_text_for_stat =~ s/\\x24/\$/g;
  $search_text_for_stat =~ s/\\x5e/\^/g;
  $search_text_for_stat =~ s/\\x2a/\*/g;
  $search_text_for_stat =~ s/\\x28/\(/g;
  $search_text_for_stat =~ s/\\x29/\)/g;
  $search_text_for_stat =~ s/\\x2b/\+/g;
  $search_text_for_stat =~ s/\\x5c/\\/g;
  $search_text_for_stat =~ s/\\x5b/\[/g;
  $search_text_for_stat =~ s/\\x7c/\|/g;
  $search_text_for_stat =~ s/\\x22/&quot;/g;
  $search_text_for_stat =~ s/\\x3f/\?/g;
  $stat_info .= ("   (".$FORM{'search_count'}." ):<br>".$search_text_for_stat);

  if($FORM{'exactly_search'} && !$replace_text){ $action_kind = " "; }
  elsif(!$FORM{'exactly_search'} && !$replace_text){ $action_kind = " "; }
  elsif($FORM{'exactly_search'} && $replace_text){ $action_kind = " "; }
  elsif(!$FORM{'exactly_search'} && $replace_text){ $action_kind = " "; }

  $stat_info .= ("-> ".$action_kind." ".(($FORM{'search_in_matched'}) ? "  " : "  " )." ".(($FORM{'no_check_register'}) ? " " : "c ")."   ...<br>");
  $stat_info .= ("->       ... ");
  read_block($FORM{'main_file'},$header_length,$strings_offset-$header_length,$strings_data_table);
  $stat_info .= ("->     ... ");
  read_block($FORM{'main_file'},$strings_offset,$file_size-$strings_offset,$strings_content);
  if(!$FORM{'exactly_search'} && !$replace_text && $FORM{'search_in_matched'} && $FORM{'no_check_register'})
   #  :          
   {
    foreach my $n(@search_in)
     {
      #   
      if($match_count eq $FORM{'search_count'}){ next; };
      #    
      my $current_offset = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+28) : get_DWORD($strings_data_table,$string_data_length*$n+18);
      #    
      my $current_length = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+32) : get_DWORD($strings_data_table,$string_data_length*$n+22);
      #    
      my $current_string = substr $strings_content,$current_offset,$current_length;
      #   
      if($current_string =~ /$search_text_1/i){ push @matched_strings,$n; $match_count++; };
      #   
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_2/i){ push @matched_strings,$n; $match_count++; };
      #   
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_3/i){ push @matched_strings,$n; $match_count++; };
      #   
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_4/i){ push @matched_strings,$n; $match_count++; };
      #   
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_5/i){ push @matched_strings,$n; $match_count++; };
      #   
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_6/i){ push @matched_strings,$n; $match_count++; };
      #   
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_7/i){ push @matched_strings,$n; $match_count++; };
      #   
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_8/i){ push @matched_strings,$n; $match_count++; };
      #   
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_9/i){ push @matched_strings,$n; $match_count++; };
     }
   #  :          
   }
  elsif($FORM{'exactly_search'} && !$replace_text && $FORM{'search_in_matched'} && $FORM{'no_check_register'})
   #  :          
   {
    foreach my $n(@search_in)
     {
      if($match_count eq $FORM{'search_count'}){ next; };
      my $current_offset = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+28) : get_DWORD($strings_data_table,$string_data_length*$n+18);
      my $current_length = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+32) : get_DWORD($strings_data_table,$string_data_length*$n+22);
      my $current_string = substr $strings_content,$current_offset,$current_length;
      if(($current_string =~ /[^a-zA-Z--]$search_text_1[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_1[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_1$/i) || ($current_string =~ /^$search_text_1$/i)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_2[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_2[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_2$/i) || ($current_string =~ /^$search_text_2$/i)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_3[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_3[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_3$/i) || ($current_string =~ /^$search_text_3$/i)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_4[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_4[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_4$/i) || ($current_string =~ /^$search_text_4$/i)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_5[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_5[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_5$/i) || ($current_string =~ /^$search_text_5$/i)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_6[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_6[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_6$/i) || ($current_string =~ /^$search_text_6$/i)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_7[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_7[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_7$/i) || ($current_string =~ /^$search_text_7$/i)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_8[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_8[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_8$/i) || ($current_string =~ /^$search_text_8$/i)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_9[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_9[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_9$/i) || ($current_string =~ /^$search_text_9$/i)){ push @matched_strings,$n; $match_count++; };
     }
   #  :          
   }
  elsif(!$FORM{'exactly_search'} && !$replace_text && $FORM{'search_in_matched'} && !$FORM{'no_check_register'})
   #  :       c   
   {
    foreach my $n(@search_in)
     {
      if($match_count eq $FORM{'search_count'}){ next; };
      my $current_offset = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+28) : get_DWORD($strings_data_table,$string_data_length*$n+18);
      my $current_length = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+32) : get_DWORD($strings_data_table,$string_data_length*$n+22);
      my $current_string = substr $strings_content,$current_offset,$current_length;
      if($current_string =~ /$search_text_1/){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_2/){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_3/){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_4/){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_5/){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_6/){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_7/){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_8/){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_9/){ push @matched_strings,$n; $match_count++; };
     }
   #  :       c   
   }
  elsif($FORM{'exactly_search'} && !$replace_text && $FORM{'search_in_matched'} && !$FORM{'no_check_register'})
   #  :       c   
   {
    foreach my $n(@search_in)
     {
      if($match_count eq $FORM{'search_count'}){ next; };
      my $current_offset = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+28) : get_DWORD($strings_data_table,$string_data_length*$n+18);
      my $current_length = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+32) : get_DWORD($strings_data_table,$string_data_length*$n+22);
      my $current_string = substr $strings_content,$current_offset,$current_length;
      if(($current_string =~ /[^a-zA-Z--]$search_text_1[^a-zA-Z--]/) || ($current_string =~ /^$search_text_1[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_1$/) || ($current_string =~ /^$search_text_1$/)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_2[^a-zA-Z--]/) || ($current_string =~ /^$search_text_2[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_2$/) || ($current_string =~ /^$search_text_2$/)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_3[^a-zA-Z--]/) || ($current_string =~ /^$search_text_3[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_3$/) || ($current_string =~ /^$search_text_3$/)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_4[^a-zA-Z--]/) || ($current_string =~ /^$search_text_4[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_4$/) || ($current_string =~ /^$search_text_4$/)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_5[^a-zA-Z--]/) || ($current_string =~ /^$search_text_5[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_5$/) || ($current_string =~ /^$search_text_5$/)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_6[^a-zA-Z--]/) || ($current_string =~ /^$search_text_6[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_6$/) || ($current_string =~ /^$search_text_6$/)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_7[^a-zA-Z--]/) || ($current_string =~ /^$search_text_7[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_7$/) || ($current_string =~ /^$search_text_7$/)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_8[^a-zA-Z--]/) || ($current_string =~ /^$search_text_8[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_8$/) || ($current_string =~ /^$search_text_8$/)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_9[^a-zA-Z--]/) || ($current_string =~ /^$search_text_9[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_9$/) || ($current_string =~ /^$search_text_9$/)){ push @matched_strings,$n; $match_count++; };
     }
   #  :       c   
   }
  elsif(!$FORM{'exactly_search'} && !$replace_text && !$FORM{'search_in_matched'} && $FORM{'no_check_register'})
   #  :          
   {
    for my $n ($start_search_position..$FORM{'file_strings'})
     {
      if($match_count eq $FORM{'search_count'}){ next; };
      my $current_offset = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+28) : get_DWORD($strings_data_table,$string_data_length*$n+18);
      my $current_length = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+32) : get_DWORD($strings_data_table,$string_data_length*$n+22);
      my $current_string = substr $strings_content,$current_offset,$current_length;
      if($current_string =~ /$search_text_1/i){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_2/i){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_3/i){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_4/i){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_5/i){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_6/i){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_7/i){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_8/i){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_9/i){ push @matched_strings,$n; $match_count++; };
     }
   #  :          
   }
  elsif($FORM{'exactly_search'} && !$replace_text && !$FORM{'search_in_matched'} && $FORM{'no_check_register'})
   #  :          
   {
    for my $n ($start_search_position..$FORM{'file_strings'})
     {
      if($match_count eq $FORM{'search_count'}){ next; };
      my $current_offset = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+28) : get_DWORD($strings_data_table,$string_data_length*$n+18);
      my $current_length = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+32) : get_DWORD($strings_data_table,$string_data_length*$n+22);
      my $current_string = substr $strings_content,$current_offset,$current_length;
      if(($current_string =~ /[^a-zA-Z--]$search_text_1[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_1[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_1$/i) || ($current_string =~ /^$search_text_1$/i)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_2[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_2[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_2$/i) || ($current_string =~ /^$search_text_2$/i)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_3[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_3[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_3$/i) || ($current_string =~ /^$search_text_3$/i)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_4[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_4[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_4$/i) || ($current_string =~ /^$search_text_4$/i)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_5[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_5[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_5$/i) || ($current_string =~ /^$search_text_5$/i)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_6[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_6[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_6$/i) || ($current_string =~ /^$search_text_6$/i)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_7[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_7[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_7$/i) || ($current_string =~ /^$search_text_7$/i)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_8[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_8[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_8$/i) || ($current_string =~ /^$search_text_8$/i)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_9[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_9[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_9$/i) || ($current_string =~ /^$search_text_9$/i)){ push @matched_strings,$n; $match_count++; };
     }
   #  :          
   }
  elsif(!$FORM{'exactly_search'} && !$replace_text && !$FORM{'search_in_matched'} && !$FORM{'no_check_register'})
   #  :          
   {
    for my $n ($start_search_position..$FORM{'file_strings'})
     {
      if($match_count eq $FORM{'search_count'}){ next; };
      my $current_offset = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+28) : get_DWORD($strings_data_table,$string_data_length*$n+18);
      my $current_length = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+32) : get_DWORD($strings_data_table,$string_data_length*$n+22);
      my $current_string = substr $strings_content,$current_offset,$current_length;
      if($current_string =~ /$search_text_1/){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_2/){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_3/){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_4/){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_5/){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_6/){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_7/){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_8/){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ /$search_text_9/){ push @matched_strings,$n; $match_count++; };
     }
   #  :          
   }
  elsif($FORM{'exactly_search'} && !$replace_text && !$FORM{'search_in_matched'} && !$FORM{'no_check_register'})
   #  :          
   {
    for my $n ($start_search_position..$FORM{'file_strings'})
     {
      if($match_count eq $FORM{'search_count'}){ next; };
      my $current_offset = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+28) : get_DWORD($strings_data_table,$string_data_length*$n+18);
      my $current_length = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+32) : get_DWORD($strings_data_table,$string_data_length*$n+22);
      my $current_string = substr $strings_content,$current_offset,$current_length;
      if(($current_string =~ /[^a-zA-Z--]$search_text_1[^a-zA-Z--]/) || ($current_string =~ /^$search_text_1[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_1$/) || ($current_string =~ /^$search_text_1$/)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_2[^a-zA-Z--]/) || ($current_string =~ /^$search_text_2[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_2$/) || ($current_string =~ /^$search_text_2$/)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_3[^a-zA-Z--]/) || ($current_string =~ /^$search_text_3[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_3$/) || ($current_string =~ /^$search_text_3$/)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_4[^a-zA-Z--]/) || ($current_string =~ /^$search_text_4[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_4$/) || ($current_string =~ /^$search_text_4$/)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_5[^a-zA-Z--]/) || ($current_string =~ /^$search_text_5[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_5$/) || ($current_string =~ /^$search_text_5$/)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_6[^a-zA-Z--]/) || ($current_string =~ /^$search_text_6[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_6$/) || ($current_string =~ /^$search_text_6$/)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_7[^a-zA-Z--]/) || ($current_string =~ /^$search_text_7[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_7$/) || ($current_string =~ /^$search_text_7$/)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_8[^a-zA-Z--]/) || ($current_string =~ /^$search_text_8[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_8$/) || ($current_string =~ /^$search_text_8$/)){ push @matched_strings,$n; $match_count++; };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_9[^a-zA-Z--]/) || ($current_string =~ /^$search_text_9[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_9$/) || ($current_string =~ /^$search_text_9$/)){ push @matched_strings,$n; $match_count++; };
     }
   #  :          
   }
  elsif(!$FORM{'exactly_search'} && $replace_text && $FORM{'search_in_matched'} && $FORM{'no_check_register'})
   #  :          
   {
    foreach my $n(@search_in)
     {
      if($match_count eq $FORM{'search_count'}){ next; };
      my $current_offset = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+28) : get_DWORD($strings_data_table,$string_data_length*$n+18);
      my $current_length = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+32) : get_DWORD($strings_data_table,$string_data_length*$n+22);
      my $current_string = substr $strings_content,$current_offset,$current_length;
      if($current_string =~ s/$search_text_1/$replace_text/gi)
       {
        #      
        push @matched_strings,$n;
        #        
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_2/$replace_text/gi)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_3/$replace_text/gi)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_4/$replace_text/gi)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_5/$replace_text/gi)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_6/$replace_text/gi)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_7/$replace_text/gi)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_8/$replace_text/gi)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_9/$replace_text/gi)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
     }
   #  :          
   }
  elsif($FORM{'exactly_search'} && $replace_text && $FORM{'search_in_matched'} && $FORM{'no_check_register'})
   #  :          
   {
    foreach my $n(@search_in)
     {
      if($match_count eq $FORM{'search_count'}){ next; };
      my $current_offset = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+28) : get_DWORD($strings_data_table,$string_data_length*$n+18);
      my $current_length = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+32) : get_DWORD($strings_data_table,$string_data_length*$n+22);
      my $current_string = substr $strings_content,$current_offset,$current_length;
      if(($current_string =~ /[^a-zA-Z--]$search_text_1[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_1[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_1$/i) || ($current_string =~ /^$search_text_1$/i))
       {
        $current_string =~ s/$search_text_1/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_2[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_2[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_2$/i) || ($current_string =~ /^$search_text_2$/i))
       {
        $current_string =~ s/$search_text_2/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_3[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_3[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_3$/i) || ($current_string =~ /^$search_text_3$/i))
       {
        $current_string =~ s/$search_text_3/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_4[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_4[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_4$/i) || ($current_string =~ /^$search_text_4$/i))
       {
        $current_string =~ s/$search_text_4/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_5[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_5[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_5$/i) || ($current_string =~ /^$search_text_5$/i))
       {
        $current_string =~ s/$search_text_5/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_6[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_6[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_6$/i) || ($current_string =~ /^$search_text_6$/i))
       {
        $current_string =~ s/$search_text_6/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_7[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_7[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_7$/i) || ($current_string =~ /^$search_text_7$/i))
       {
        $current_string =~ s/$search_text_7/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_8[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_8[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_8$/i) || ($current_string =~ /^$search_text_8$/i))
       {
        $current_string =~ s/$search_text_8/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_9[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_9[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_9$/i) || ($current_string =~ /^$search_text_9$/i))
       {
        $current_string =~ s/$search_text_9/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
     }
   #  :          
   }
  elsif(!$FORM{'exactly_search'} && $replace_text && $FORM{'search_in_matched'} && !$FORM{'no_check_register'})
   #  :          
   {
    foreach my $n(@search_in)
     {
      if($match_count eq $FORM{'search_count'}){ next; };
      my $current_offset = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+28) : get_DWORD($strings_data_table,$string_data_length*$n+18);
      my $current_length = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+32) : get_DWORD($strings_data_table,$string_data_length*$n+22);
      my $current_string = substr $strings_content,$current_offset,$current_length;
      if($current_string =~ s/$search_text_1/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_2/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_3/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_4/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_5/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_6/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_7/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_8/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_9/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
     }
   #  :          
   }
  elsif($FORM{'exactly_search'} && $replace_text && $FORM{'search_in_matched'} && !$FORM{'no_check_register'})
   #  :          
   {
    foreach my $n(@search_in)
     {
      if($match_count eq $FORM{'search_count'}){ next; };
      my $current_offset = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+28) : get_DWORD($strings_data_table,$string_data_length*$n+18);
      my $current_length = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+32) : get_DWORD($strings_data_table,$string_data_length*$n+22);
      my $current_string = substr $strings_content,$current_offset,$current_length;
      if(($current_string =~ /[^a-zA-Z--]$search_text_1[^a-zA-Z--]/) || ($current_string =~ /^$search_text_1[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_1$/) || ($current_string =~ /^$search_text_1$/))
       {
        $current_string =~ s/$search_text_1/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_2[^a-zA-Z--]/) || ($current_string =~ /^$search_text_2[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_2$/) || ($current_string =~ /^$search_text_2$/))
       {
        $current_string =~ s/$search_text_2/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_3[^a-zA-Z--]/) || ($current_string =~ /^$search_text_3[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_3$/) || ($current_string =~ /^$search_text_3$/))
       {
        $current_string =~ s/$search_text_3/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_4[^a-zA-Z--]/) || ($current_string =~ /^$search_text_4[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_4$/) || ($current_string =~ /^$search_text_4$/))
       {
        $current_string =~ s/$search_text_4/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_5[^a-zA-Z--]/) || ($current_string =~ /^$search_text_5[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_5$/) || ($current_string =~ /^$search_text_5$/))
       {
        $current_string =~ s/$search_text_5/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_6[^a-zA-Z--]/) || ($current_string =~ /^$search_text_6[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_6$/) || ($current_string =~ /^$search_text_6$/))
       {
        $current_string =~ s/$search_text_6/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_7[^a-zA-Z--]/) || ($current_string =~ /^$search_text_7[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_7$/) || ($current_string =~ /^$search_text_7$/))
       {
        $current_string =~ s/$search_text_7/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_8[^a-zA-Z--]/) || ($current_string =~ /^$search_text_8[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_8$/) || ($current_string =~ /^$search_text_8$/))
       {
        $current_string =~ s/$search_text_8/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_9[^a-zA-Z--]/) || ($current_string =~ /^$search_text_9[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_9$/) || ($current_string =~ /^$search_text_9$/))
       {
        $current_string =~ s/$search_text_9/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
     }
   #  :          
   }
  elsif(!$FORM{'exactly_search'} && $replace_text && !$FORM{'search_in_matched'} && $FORM{'no_check_register'})
   #  :          
   {
    for my $n ($start_search_position..$FORM{'file_strings'})
     {
      if($match_count eq $FORM{'search_count'}){ next; };
      my $current_offset = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+28) : get_DWORD($strings_data_table,$string_data_length*$n+18);
      my $current_length = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+32) : get_DWORD($strings_data_table,$string_data_length*$n+22);
      my $current_string = substr $strings_content,$current_offset,$current_length;
      if($current_string =~ s/$search_text_1/$replace_text/gi)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_2/$replace_text/gi)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_3/$replace_text/gi)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_4/$replace_text/gi)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_5/$replace_text/gi)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_6/$replace_text/gi)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_7/$replace_text/gi)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_8/$replace_text/gi)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_9/$replace_text/gi)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
     }
   #  :          
   }
  elsif($FORM{'exactly_search'} && $replace_text && !$FORM{'search_in_matched'} && $FORM{'no_check_register'})
   #  :          
   {
    for my $n ($start_search_position..$FORM{'file_strings'})
     {
      if($match_count eq $FORM{'search_count'}){ next; };
      my $current_offset = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+28) : get_DWORD($strings_data_table,$string_data_length*$n+18);
      my $current_length = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+32) : get_DWORD($strings_data_table,$string_data_length*$n+22);
      my $current_string = substr $strings_content,$current_offset,$current_length;
      if(($current_string =~ /[^a-zA-Z--]$search_text_1[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_1[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_1$/i) || ($current_string =~ /^$search_text_1$/i))
       {
        $current_string =~ s/$search_text_1/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_2[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_2[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_2$/i) || ($current_string =~ /^$search_text_2$/i))
       {
        $current_string =~ s/$search_text_2/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_3[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_3[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_3$/i) || ($current_string =~ /^$search_text_3$/i))
       {
        $current_string =~ s/$search_text_3/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_4[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_4[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_4$/i) || ($current_string =~ /^$search_text_4$/i))
       {
        $current_string =~ s/$search_text_4/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_5[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_5[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_5$/i) || ($current_string =~ /^$search_text_5$/i))
       {
        $current_string =~ s/$search_text_5/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_6[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_6[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_6$/i) || ($current_string =~ /^$search_text_6$/i))
       {
        $current_string =~ s/$search_text_6/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_7[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_7[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_7$/i) || ($current_string =~ /^$search_text_7$/i))
       {
        $current_string =~ s/$search_text_7/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_8[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_8[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_8$/i) || ($current_string =~ /^$search_text_8$/i))
       {
        $current_string =~ s/$search_text_8/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_9[^a-zA-Z--]/i) || ($current_string =~ /^$search_text_9[^a-zA-Z--]/i) || ($current_string =~ /[^a-zA-Z--]$search_text_9$/i) || ($current_string =~ /^$search_text_9$/i))
       {
        $current_string =~ s/$search_text_9/$replace_text/gi;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
     }
   #  :          
   }
  elsif(!$FORM{'exactly_search'} && $replace_text && !$FORM{'search_in_matched'} && !$FORM{'no_check_register'})
   #  :          
   {
    for my $n ($start_search_position..$FORM{'file_strings'})
     {
      if($match_count eq $FORM{'search_count'}){ next; };
      my $current_offset = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+28) : get_DWORD($strings_data_table,$string_data_length*$n+18);
      my $current_length = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+32) : get_DWORD($strings_data_table,$string_data_length*$n+22);
      my $current_string = substr $strings_content,$current_offset,$current_length;
      if($current_string =~ s/$search_text_1/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_2/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_3/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_4/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_5/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_6/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_7/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_8/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if($current_string =~ s/$search_text_9/$replace_text/g)
       {
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
     }
   #  :          
   }
  elsif($FORM{'exactly_search'} && $replace_text && !$FORM{'search_in_matched'} && !$FORM{'no_check_register'})
   #  :          
   {
    for my $n ($start_search_position..$FORM{'file_strings'})
     {
      if($match_count eq $FORM{'search_count'}){ next; };
      my $current_offset = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+28) : get_DWORD($strings_data_table,$string_data_length*$n+18);
      my $current_length = ($file_version eq "V3.0") ? get_DWORD($strings_data_table,$string_data_length*$n+32) : get_DWORD($strings_data_table,$string_data_length*$n+22);
      my $current_string = substr $strings_content,$current_offset,$current_length;
      if(($current_string =~ /[^a-zA-Z--]$search_text_1[^a-zA-Z--]/) || ($current_string =~ /^$search_text_1[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_1$/) || ($current_string =~ /^$search_text_1$/))
       {
        $current_string =~ s/$search_text_1/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_2[^a-zA-Z--]/) || ($current_string =~ /^$search_text_2[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_2$/) || ($current_string =~ /^$search_text_2$/))
       {
        $current_string =~ s/$search_text_2/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_3[^a-zA-Z--]/) || ($current_string =~ /^$search_text_3[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_3$/) || ($current_string =~ /^$search_text_3$/))
       {
        $current_string =~ s/$search_text_3/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_4[^a-zA-Z--]/) || ($current_string =~ /^$search_text_4[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_4$/) || ($current_string =~ /^$search_text_4$/))
       {
        $current_string =~ s/$search_text_4/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_5[^a-zA-Z--]/) || ($current_string =~ /^$search_text_5[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_5$/) || ($current_string =~ /^$search_text_5$/))
       {
        $current_string =~ s/$search_text_5/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_6[^a-zA-Z--]/) || ($current_string =~ /^$search_text_6[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_6$/) || ($current_string =~ /^$search_text_6$/))
       {
        $current_string =~ s/$search_text_6/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_7[^a-zA-Z--]/) || ($current_string =~ /^$search_text_7[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_7$/) || ($current_string =~ /^$search_text_7$/))
       {
        $current_string =~ s/$search_text_7/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_8[^a-zA-Z--]/) || ($current_string =~ /^$search_text_8[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_8$/) || ($current_string =~ /^$search_text_8$/))
       {
        $current_string =~ s/$search_text_8/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
      if($match_count eq $FORM{'search_count'}){ next; };
      if(($current_string =~ /[^a-zA-Z--]$search_text_9[^a-zA-Z--]/) || ($current_string =~ /^$search_text_9[^a-zA-Z--]/) || ($current_string =~ /[^a-zA-Z--]$search_text_9$/) || ($current_string =~ /^$search_text_9$/))
       {
        $current_string =~ s/$search_text_9/$replace_text/g;
        push @matched_strings,$n;
        push @replaced_number,$n; push @replaced_contents,$current_string;
        $match_count++;
       };
     }
   #  :          
   }


if(($#matched_strings+1) != 0)
 { $stat_info .= ("->    : ".($#matched_strings+1)." ...   ".$matched_strings[0]."   ".$matched_strings[$#matched_strings]."<br>"); }
else{ $stat_info .= (":          ...<br>"); reset_document(); }

#$stat_info .= ("   : ".(join ", ",@matched_strings)."<br>");
if(@matched_strings){ $FORM{'string_number'} = $matched_strings[0]; };
#        
$matched_strings_joined = join ",",@matched_strings;
if($replace_text)
 {
  $stat_info .= ("->    ".$match_count." <br>");
  #       
  $replaced_numbers_joined = join ",",@replaced_number;
  #      
  $replaced_contents_joined = join "{!join!}",@replaced_contents;
  #  ,        
  #$replaced_contents_joined =~ s/\x5c/\\x5c/g;
  $replaced_contents_joined =~ s/\x0a/\\x0a/g;
  $replaced_contents_joined =~ s/\x22/\\x22/g;
 };

#  
$stat_info .= ("   ".$FORM{'string_number'}." ...<br>");
if(!@replaced_contents[0])
 {
  $stat_info .= ("->      ... ");
  read_block($FORM{'main_file'},$string_data_length*$FORM{'string_number'}+$header_length,$string_data_length,$sdt_offset);
  if($file_version eq "V3.0")
   {
    #  
    $string_flag = get_DWORD($sdt_offset,0);
    #     
    $sound_link = (substr $sdt_offset,4,16); $sound_link =~ s/\W//g; if($sound_link eq ""){ $sound_link = ""; };
    #     
    $string_offset = ($strings_offset + get_DWORD($sdt_offset,28));
    #    
    $string_length = get_DWORD($sdt_offset,32);
    #      
    $sound_volume = get_DWORD($sdt_offset,20);
    #  /    
    $sound_pitch = get_DWORD($sdt_offset,24);
    #    32-   
    $sound_length = unpack "f", (substr $sdt_offset,36,4);
   }
  elsif($file_version eq "V1  ")
   {
    $string_flag = get_WORD($sdt_offset,0);
    $sound_link = (substr $sdt_offset,2,8); $sound_link =~ s/\W//g; if($sound_link eq ""){ $sound_link = ""; };
    $string_offset = ($strings_offset + get_DWORD($sdt_offset,18));
    $string_length = get_DWORD($sdt_offset,22);
    $sound_volume = get_DWORD($sdt_offset,10);
    $sound_pitch = get_DWORD($sdt_offset,14);
    $sound_length = " ";
   }
  $stat_info .= ("->    ... ");
  read_block($FORM{'main_file'},$string_offset,$string_length,$string_text);
 };

#       
if($FORM{'add_file'} ne "")
 {
  if(!-r $FORM{'add_file'}){ $stat_info .= (":  ".$FORM{'add_file'}."       !<br>"); reset_document(); };
  open FILE2,$FORM{'add_file'}; binmode FILE2;
  #   
  seek FILE2,4,0; read FILE2,$file2_version,4;
  #   
  seek FILE2,0,0; read FILE2,$file2_type,4;
  if($file2_type ne "TLK ")
   { $stat_info .= (":   ".$FORM{'add_file'}."   TLK !<br>"); }
  elsif($file2_version eq "V3.0")
   {
    #  
    $header2_length = 20;
    #    
    $string2_data_length = 40;
    #    
    seek FILE2,12,0; read FILE2,$file2_strings,4; $file2_strings = (unpack "V", $file2_strings) - 1;
    #        
    seek FILE2,16,0; read FILE2,$strings2_offset,4; $strings2_offset = unpack "V", $strings2_offset;
    #     
    $string2_number = ($FORM{'string_number'} < $file2_strings) ? $FORM{'string_number'} : $file2_strings;
    #   2   
    seek FILE2,$header2_length + $string2_data_length * $string2_number,0; read FILE2,$sdt2_offset,$string2_data_length;
    $string2_offset = $strings2_offset + (unpack "V", substr $sdt2_offset,28,4);
    #   2  
    $string2_length = unpack "V", substr $sdt2_offset,32,4;
    #   2
    seek FILE2,$string2_offset,0; read FILE2,$string2_text,$string2_length;
   }
  elsif($file2_version eq "V1  ")
   {
    $header2_length = 18;
    $string2_data_length = 26;
    seek FILE2,10,0; read FILE2,$file2_strings,4; $file2_strings = (unpack "V", $file2_strings) - 1;
    seek FILE2,14,0; read FILE2,$strings2_offset,4; $strings2_offset = unpack "V", $strings2_offset;
    $string2_number = ($FORM{'string_number'} < $file2_strings) ? $FORM{'string_number'} : $file2_strings;
    seek FILE2,$header2_length + $string2_data_length * $string2_number,0; read FILE2,$sdt2_offset,$string2_data_length;
    $string2_offset = $strings2_offset + (unpack "V", substr $sdt2_offset,18,4);
    $string2_length = unpack "V", substr $sdt2_offset,22,4;
    seek FILE2,$string2_offset,0; read FILE2,$string2_text,$string2_length;
   }
  else{ $stat_info .= (":    ".$FORM{'add_file'}."  !<br>"); }
  close FILE2;
  if($file2_type eq "TLK " && ($file2_version eq "V3.0" || $file2_version eq "V1  "))
   {
    $stat_info .= ("->  : ".$FORM{'add_file'}." ...<br>-> : $file2_type, : $file2_version<br>-> : $string2_number ... $string2_length    $string2_offset<br>");
    #   (5c),   (0a  0d)   (22)  
    $string2_text =~ s/\x5c/\\x5c/g;
    $string2_text =~ s/\x0a/\\x0a/g;
    $string2_text =~ s/\x0d/\\x0d/g;
    $string2_text =~ s/\x22/\\x22/g;
   }
 };

#   (5c),   (0a  0d)   (22)  
$string_text =~ s/\x5c/\\x5c/g;
$string_text =~ s/\x0a/\\x0a/g;
if($string_text =~ /\x0d/){ $stat_info .= ("->     ...<br>"); $string_text =~ s/\x0d/\\x0d/g; };
$string_text =~ s/\x22/\\x22/g;

$stat_info =~ s/\x5c/\\x5c/g;

my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";

#      
print <<HTML;
<script type='text/javascript'><!--

if("$FORM{'add_file'}" != "")
 {
  parent.document.main_form.string_content2.value = "$string2_text";
  parent.document.main_form.string_content2.title = " .   $string2_number;         .";
 };

parent.document.getElementById("search_nav").style.display = "";
parent.document.main_form.search_in_matched.disabled = false;
parent.document.getElementById("matched_strings_tooltip").title = ("$search_tooltip") ? "$search_tooltip" : "$search_text";
parent.matched_strings = "$matched_strings_joined".split(",");
for(n = 0; n < parent.matched_strings.length; n++)
 { parent.matched_links[parent.matched_strings[n]] = n; }
parent.current_search_position = 0;
parent.document.main_form.input_matched_string.value = 1;
parent.document.main_form.input_matched_strings.value = parent.matched_strings.length;

if(parent.document.main_form.string_number.value != parent.matched_strings[0])
 { parent.last_string_number = parent.document.main_form.string_number.value;
   parent.document.main_form.string_number.value = parent.matched_strings[0];
   parent.current_string_number = parent.document.main_form.string_number.value; };

if("$#replaced_contents" != "-1")
 {
  var replaced_numbers = new Array(); replaced_numbers = "$replaced_numbers_joined".split(",");
  var replaced_contents = new Array(); replaced_contents = "$replaced_contents_joined".split("{!join!}");

  parent.document.main_form.string_content.value = replaced_contents[0];

  var last_changed_position = (parent.changed_string_number.length) ? parent.changed_string_number.length-1 : 0;
  for(i = 0; i < replaced_numbers.length; i++)
   {
    parent.changed_string_number.push(replaced_numbers[i]);
    parent.changed_string_content.push(replaced_contents[i]);
   }

  parent.document.getElementById("string_info").style.display = "none";
  parent.document.getElementById("string_no_info").style.display = "";
  parent.document.main_form.to_undo_button.style.display = "none";
  parent.document.main_form.from_undo_button.style.display = "";

  parent.document.main_form.input_changed_string.value = last_changed_position + 1;
  parent.current_changed_position = last_changed_position;
  parent.document.main_form.input_changed_strings.value = parent.changed_string_number.length;
  parent.count_string_changes();
  parent.undo_redo_update();
 }
else
 {
  parent.document.main_form.string_content.value = "$string_text";

  parent.document.getElementById("string_info").style.display = "";
  parent.document.getElementById("string_no_info").style.display = "none";
  parent.document.main_form.to_undo_button.style.display = "";
  parent.document.main_form.from_undo_button.style.display = "none";

  parent.document.getElementById("string_flag").innerHTML = "$string_flag";
  parent.document.getElementById("string_length").innerHTML = "$string_length";
  parent.document.getElementById("string_offset").innerHTML = "$string_offset";
  parent.document.getElementById("sound_link").innerHTML = "$sound_link";
  parent.document.getElementById("sound_volume").innerHTML = "$sound_volume";
  parent.document.getElementById("sound_pitch").innerHTML = "$sound_pitch";
  parent.document.getElementById("sound_length").innerHTML = "$sound_length";
 }

if("$FORM{'file_size'}" != "$file_size")
 {
  parent.document.main_form.file_size.value = "$file_size";
  parent.document.main_form.file_type.value = "$file_type";
  parent.document.main_form.file_version.value = "$file_version";
  parent.document.main_form.languageID.value = "$languageID";
  parent.document.main_form.strings_offset.value = "$strings_offset";
  parent.document.main_form.file_strings.value = "$file_strings";
  parent.document.main_form.current_file_strings.value = "$file_strings";
  parent.document.getElementById("file_info").innerHTML = ": $file_size , : $file_type, : $file_version, : $file_language (<span style='cursor: help;' title='  , languageID.'>$languageID</span>)";
 };

if(parent.document.getElementById('patch_file_menu').style.display == '')
 {
  parent.document.getElementById('save_changes_tbody').style.display = (parent.matched_strings.length > 0 || parent.changed_string_number.length > 0) ? '' : 'none';
  parent.check_save_patch();
 };

parent.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == 1) ? ("$full_stat_info" + parent.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
parent.document.search_in_tlk_form.reset();
parent.FLAG_no_action = 0;
parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
// --></script>
HTML
